var Core = require('core');
var ProxyLoader = require('./ProxyLoader.js').ProxyLoader;


var QueryMethod = function () {
    this.Extends = Core.JsonRpc.JsonRpcMethod;
    
    this.execute = function (params) {
        try {
            console.log('     -- QueryMethod: creating ProxyLoader');
            var proxyLoader = new ProxyLoader(
                new Core.Net.Request(params.request),
                this.server.getConfiguration()
            );
            proxyLoader.addEventListener(ProxyLoader.LOADED, this._onSuccess, this);
            proxyLoader.addEventListener(ProxyLoader.ERROR,  this._onError,   this);
            console.log('     -- QueryMethod: executing ProxyLoader');
            proxyLoader.load();

         } catch(e) {
            e.code = -1; // domyslnie exceptiony nie maja kodu bledu
            console.log('     -- QueryMethod: ERROR while initializing ProxyLoader');
            console.log('     -- QueryMethod: ERROR code: ' + e.code + " ; msg: " + e.message);
            console.log('     -- QueryMethod: dispatching ERROR event...');
            this.dispatchEvent( new Core.Event.ErrorEvent(Core.JsonRpc.JsonRpcMethod.Event.ERROR, e, e.code, e.message) );
         }
    };
    
    this._onSuccess = function(e){
        console.log('     -- QueryMethod: received LOADED event...');
		var response = e.data;
        this._response.setStatusCode(200);
        this._response.setHeader('Access-Control-Allow-Origin', '*');
        this._response.setBody(response.toBinaryData());
        console.log('     -- QueryMethod: dispatching OK event...');
        this.dispatchEvent( new Core.Event.Event(Core.JsonRpc.JsonRpcMethod.Event.OK) );
    };

    this._onError = function(e){
        console.log('     -- QueryMethod: received ERROR event...');
        console.log('     -- QueryMethod: ERROR code: ' + e.data.code + " ; msg: " + e.data.message);
        console.log('     -- QueryMethod: dispatching ERROR event...');
        this.dispatchEvent( new Core.Event.ErrorEvent(Core.JsonRpc.JsonRpcMethod.Event.ERROR, e, e.data.code, 'ProxyLoader: ' + e.data.message) );
    };
   
};

QueryMethod = new Core.Class(new QueryMethod());
exports.QueryMethod = QueryMethod;